-- name: [CS] Classic Sonic Pack
-- description: \\#ffffff\\It's Classic \\#2448D8\\Sonic\\#ffffff\\, \\#FC9000\\Tails\\#ffffff\\, \\#D80024\\Knuckles\\#ffffff\\, and \\#8F0000\\Eggman\\#ffffff\\, but for Coop DX!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local globalModName = "Classic Sonic Pack"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_CSONIC_MODEL = smlua_model_util_get_id("ClassicSonic_geo") -- Located in "actors"
local E_CTAILS_MODEL = smlua_model_util_get_id("ClassicTails_geo") -- Located in "actors"
local E_CKNUCKLES_MODEL = smlua_model_util_get_id("ClassicKnuckles_geo") -- Located in "actors"
local E_CEGGMAN_MODEL = smlua_model_util_get_id("ClassicEggman_geo") -- Located in "actors"
local E_CSUPERSONIC_MODEL = smlua_model_util_get_id("ClassicSuperSonic_geo") -- Located in "actors"

local TEX_CSONIC_LIFE_ICON = get_texture_info("s3-sonic-life") -- Located in "textures"
local TEX_CTAILS_LIFE_ICON = get_texture_info("s3-tails-life") -- Located in "textures"
local TEX_CKNUCKLES_LIFE_ICON = get_texture_info("s3-knux-life") -- Located in "textures"
local TEX_CEGGMAN_LIFE_ICON = get_texture_info("s3-egg-monitor") -- Located in "textures"
local TEX_CSUPERSONIC_LIFE_ICON = get_texture_info("s3-ssonic-life") -- Located in "textures"

local VOICETABLE_CSONIC = {
    [CHAR_SOUND_ATTACKED] = 's-losering.ogg',
    [CHAR_SOUND_DOH] = 's-bounce.ogg',
    [CHAR_SOUND_DROWNING] = 's-drown.ogg',
    [CHAR_SOUND_DYING] = 's-death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 's-hurtboss.ogg',
    [CHAR_SOUND_HAHA] = 's-checkpoint.ogg',
    [CHAR_SOUND_HAHA_2] = 's-checkpoint.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 's-bonus.ogg',
    [CHAR_SOUND_HOOHOO] = 's2-jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 's-flyaway.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 's-warp.ogg',
    [CHAR_SOUND_ON_FIRE] = 's-shoot.ogg',
    [CHAR_SOUND_OOOF] = 's-death.ogg',
    [CHAR_SOUND_OOOF2] = 's-death.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 's-bumper.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 's-boostpad.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 's-boostpad.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 's-score.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 's-item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 's-falling.ogg',
    [CHAR_SOUND_WAH2] = 's-bumper.ogg',
    [CHAR_SOUND_WHOA] = 's-item.ogg',
    [CHAR_SOUND_YAHOO] = 's3-jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 's3-jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 's1-jump.ogg',
    [CHAR_SOUND_YAWNING] = 's-spike.ogg',
}

local VOICETABLE_CEGGMAN = {
    [CHAR_SOUND_ATTACKED] = 'damage-boss.ogg',
    [CHAR_SOUND_DOH] = 's-bounce.ogg',
    [CHAR_SOUND_DROWNING] = 's-drown.ogg',
    [CHAR_SOUND_DYING] = 's-death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 's-hurtboss.ogg',
    [CHAR_SOUND_HAHA] = 's-checkpoint.ogg',
    [CHAR_SOUND_HAHA_2] = 's-checkpoint.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'PINGAS.ogg',
    [CHAR_SOUND_HOOHOO] = 'bounce2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 's-flyaway.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 's-warp.ogg',
    [CHAR_SOUND_ON_FIRE] = 's-shoot.ogg',
    [CHAR_SOUND_OOOF] = 's-death.ogg',
    [CHAR_SOUND_OOOF2] = 's-death.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 's-bumper.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 's-boostpad.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 's-boostpad.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 's-score.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 's-item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 's-falling.ogg',
    [CHAR_SOUND_WAH2] = 's-bumper.ogg',
    [CHAR_SOUND_WHOA] = 's-item.ogg',
    [CHAR_SOUND_YAHOO] = 'bubble.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'bubble.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'bounce1.ogg',
    [CHAR_SOUND_YAWNING] = 's-spike.ogg',
}

local PALETTE_CSONIC = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "2342BD",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF0000",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FEC179",
    [CAP]    = "FFE900",
    [EMBLEM]  = "362020",
}

local PALETTE_CTAILS = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "F89A17",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF0000",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FFFFFF",
    [CAP]    = "262626",
    [EMBLEM]  = "362020",
}

local PALETTE_CKNUCKLES = {
    [PANTS]  = "00A209",
    [SHIRT]  = "D80019",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF0000",
    [HAIR]   = "FF9D00",
    [SKIN]   = "E1A56B",
    [CAP]    = "FFFFFF",
    [EMBLEM]  = "99ACB5",
}

local PALETTE_CEGGMAN = {
    [PANTS]  = "1A1A1A",
    [SHIRT]  = "FF0025",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "1A1A1A",
    [HAIR]   = "6A1914",
    [SKIN]   = "FEBB78",
    [CAP]    = "FFFF00",
    [EMBLEM]  = "FF7D98",
}

local PALETTE_CSUPERSONIC = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FCD900",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF0000",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FEC179",
    [CAP]    = "FFE900",
    [EMBLEM]  = "362020",
}

local CSloaded = false
local function on_character_select_load()
    CT_CSONIC = _G.charSelect.character_add("Classic Sonic", {"The blue blur in his classic form.", ""}, "MrGameAndSketch", {r = 36, g = 72, b = 216}, E_CSONIC_MODEL, CT_CSONIC, TEX_CSONIC_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CSONIC_MODEL, VOICETABLE_CSONIC)
    _G.charSelect.character_add_palette_preset(E_CSONIC_MODEL, PALETTE_CSONIC)

    CT_CTAILS = _G.charSelect.character_add("Classic Tails", {"The ever-reliable flying sidekick, now in Coop DX.", ""}, "MrGameAndSketch", {r = 252, g = 144, b = 0}, E_CTAILS_MODEL, CT_CTAILS, TEX_CTAILS_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CTAILS_MODEL, VOICETABLE_CSONIC)
    _G.charSelect.character_add_palette_preset(E_CTAILS_MODEL, PALETTE_CTAILS)

    CT_CKNUCKLES = _G.charSelect.character_add("Classic Knuckles", {"He's rougher than the rest of them.", ""}, "MrGameAndSketch", {r = 216, g = 0, b = 36}, E_CKNUCKLES_MODEL, CT_CKNUCKLES, TEX_CKNUCKLES_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CKNUCKLES_MODEL, VOICETABLE_CSONIC)
    _G.charSelect.character_add_palette_preset(E_CKNUCKLES_MODEL, PALETTE_CKNUCKLES)

    CT_CEGGMAN = _G.charSelect.character_add("Classic Eggman", {"My Saturn Classic Eggman model, but in Coop DX.", ""}, "MrGameAndSketch", {r = 143, g = 0, b = 0}, E_CEGGMAN_MODEL, CT_CEGGMAN, TEX_CEGGMAN_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CEGGMAN_MODEL, VOICETABLE_CEGGMAN)
    _G.charSelect.character_add_palette_preset(E_CEGGMAN_MODEL, PALETTE_CEGGMAN)

    CT_CSUPERSONIC = _G.charSelect.character_add("Classic Super Sonic", {"It's Sonic, but he's super now. Cool.", ""}, "MrGameAndSketch", {r = 252, g = 252, b = 0}, E_CSUPERSONIC_MODEL, CT_CSUPERSONIC, TEX_CSUPERSONIC_LIFE_ICON)
    _G.charSelect.character_add_voice(E_CSUPERSONIC_MODEL, VOICETABLE_CSONIC)
    _G.charSelect.character_add_palette_preset(E_CSUPERSONIC_MODEL, PALETTE_CSUPERSONIC)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CSONIC then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CEGGMAN then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SONIC then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)